#include "msg.h"

#define _XOPEN_SOURCE 600
#include <time.h>
#include <mqueue.h>
/* #include <signal.h> */
/* #include <stdio.h> */
/* #include <errno.h> */
/* #include <string.h> */
/* #include <stdbool.h> */
/* #include <unistd.h> */

/* Read from a message queue, counting all messages until empty.  Each
 * message signifies someone pushing a panic button. */
int pb_count(mqd_t qid)
{
	Msg msg = {0,0,0};
	unsigned int priority = 0;
	struct timespec ts = {time(0) + 5, 0};
	int count = 0;

	/* Loop for a maximum of 5-seconds, pulling messages out of
	 * the queue.  Each message indicates one push of a panic
	 * button. */
	while ( -1 !=
		(mq_timedreceive(qid, (char*) &msg,
				 sizeof(msg), &priority, &ts)) )
	{
		count++;
	}
	return count;
}
