/* #include <stdio.h> */
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>

/* Taken from /heg/demo/zorglub/i2c_ism.h */
#define IOCTL_ISM_GET_STAT  0x06

int active_buttons(void)
{
	static uint8_t stat_table[13];
	int i;
	int active;
	int ret;
	int icarm_fd;

	if ( (icarm_fd = open("/dev/ism", O_RDONLY)) < 0 )
		return -1;

	memset(stat_table, 0x00, sizeof(stat_table));
	ret = ioctl(icarm_fd, IOCTL_ISM_GET_STAT, stat_table);
	close(icarm_fd);

	if ( 0xA5 != stat_table[0] )
		return -1;

	active = 0;
	for ( i = 2; i < ret - 3; i++ )
	{
		if ( 0x02 & stat_table[i] )
			active++;
	}
	return active;
}
